## bfs 3.0

=== Makefile ===
# Copyright © Tavian Barnes <tavianator@tavianator.com>
# SPDX-License-Identifier: 0BSD

ifneq ($(wildcard .git),)
VERSION := $(shell git describe --always 2>/dev/null)
endif

ifndef VERSION
VERSION := 3.0
endif

ifndef OS
OS := $(shell uname)
endif

ifndef ARCH
ARCH := $(shell uname -m)
endif

CC ?= gcc
INSTALL ?= install
MKDIR ?= mkdir -p
RM ?= rm -f

export BUILDDIR ?= .
DESTDIR ?=
PREFIX ?= /usr
MANDIR ?= $(PREFIX)/share/man

BIN := $(BUILDDIR)/bin
OBJ := $(BUILDDIR)/obj

DEFAULT_CFLAGS := \
    -g \
    -Wall \
    -Wformat=2 \
    -Werror=implicit \
    -Wimplicit-fallthrough \
    -Wmissing-declarations \
    -Wshadow \
    -Wsign-compare \
    -Wstrict-prototypes

CFLAGS ?= $(DEFAULT_CFLAGS)
LDFLAGS ?=
DEPFLAGS ?= -MD -MP -MF $(@:.o=.d)

LOCAL_CPPFLAGS := \
    -D__EXTENSIONS__ \
    -D_ATFILE_SOURCE \
    -D_BSD_SOURCE \
    -D_DARWIN_C_SOURCE \
    -D_DEFAULT_SOURCE \
    -D_GNU_SOURCE \
    -D_LARGEFILE64_SOURCE \
    -D_FILE_OFFSET_BITS=64 \
    -D_TIME_BITS=64 \
    -DBFS_VERSION=\"$(VERSION)\"

LOCAL_CFLAGS := -std=c17 -pthread
LOCAL_LDFLAGS :=
LOCAL_LDLIBS :=

ASAN := $(filter asan,$(MAKECMDGOALS))
LSAN := $(filter lsan,$(MAKECMDGOALS))
MSAN := $(filter msan,$(MAKECMDGOALS))
TSAN := $(filter tsan,$(MAKECMDGOALS))
UBSAN := $(filter ubsan,$(MAKECMDGOALS))

ifdef ASAN
LOCAL_CFLAGS += -fsanitize=address
SANITIZE := y
endif

ifdef LSAN
LOCAL_CFLAGS += -fsanitize=leak
SANITIZE := y
endif

ifdef MSAN
# msan needs all code instrumented
NOLIBS := y
LOCAL_CFLAGS += -fsanitize=memory -fsanitize-memory-track-origins
SANITIZE := y
endif

ifdef TSAN
# tsan needs all code instrumented
NOLIBS := y
# https://github.com/google/sanitizers/issues/342
LOCAL_CPPFLAGS += -DBFS_USE_TARGET_CLONES=0
LOCAL_CFLAGS += -fsanitize=thread
SANITIZE := y
endif

ifdef UBSAN
LOCAL_CFLAGS += -fsanitize=undefined
SANITIZE := y
endif

ifdef SANITIZE
LOCAL_CFLAGS += -fno-sanitize-recover=all
endif

ifndef NOLIBS
USE_ONIGURUMA := y
endif

ifdef USE_ONIGURUMA
LOCAL_CPPFLAGS += -DBFS_USE_ONIGURUMA=1

ONIG_CONFIG := $(shell command -v onig-config 2>/dev/null)
ifdef ONIG_CONFIG
ONIG_CFLAGS := $(shell $(ONIG_CONFIG) --cflags)
ONIG_LDLIBS := $(shell $(ONIG_CONFIG) --libs)
else
ONIG_LDLIBS := -lonig
endif

LOCAL_CFLAGS += $(ONIG_CFLAGS)
LOCAL_LDLIBS += $(ONIG_LDLIBS)
endif # USE_ONIGURUMA

ifeq ($(OS),Linux)
ifndef NOLIBS
USE_ACL := y
USE_ATTR := y
USE_LIBCAP := y
endif

ifdef USE_ACL
LOCAL_LDLIBS += -lacl
else
LOCAL_CPPFLAGS += -DBFS_USE_SYS_ACL_H=0
endif

ifdef USE_ATTR
LOCAL_LDLIBS += -lattr
else
LOCAL_CPPFLAGS += -DBFS_USE_SYS_XATTR_H=0
endif

ifdef USE_LIBCAP
LOCAL_LDLIBS += -lcap
else
LOCAL_CPPFLAGS += -DBFS_USE_SYS_CAPABILITY_H=0
endif

LOCAL_LDFLAGS += -Wl,--as-needed
LOCAL_LDLIBS += -lrt
endif # Linux

ifeq ($(OS),NetBSD)
LOCAL_LDLIBS += -lutil
endif

ifneq ($(filter gcov,$(MAKECMDGOALS)),)
LOCAL_CFLAGS += --coverage
# gcov only intercepts fork()/exec() with -std=gnu*
LOCAL_CFLAGS := $(patsubst -std=c%,-std=gnu%,$(LOCAL_CFLAGS))
endif

ifneq ($(filter release,$(MAKECMDGOALS)),)
LOCAL_CPPFLAGS += -DNDEBUG
CFLAGS := $(DEFAULT_CFLAGS) -O3 -flto
endif

ALL_CPPFLAGS = $(LOCAL_CPPFLAGS) $(CPPFLAGS) $(EXTRA_CPPFLAGS)
ALL_CFLAGS = $(ALL_CPPFLAGS) $(LOCAL_CFLAGS) $(CFLAGS) $(EXTRA_CFLAGS) $(DEPFLAGS)
ALL_LDFLAGS = $(ALL_CFLAGS) $(LOCAL_LDFLAGS) $(LDFLAGS) $(EXTRA_LDFLAGS)
ALL_LDLIBS = $(LOCAL_LDLIBS) $(LDLIBS) $(EXTRA_LDLIBS)

# Default make target
bfs: $(BIN)/bfs
.PHONY: bfs

# Goals that are treated like flags by this Makefile
FLAG_GOALS := asan lsan msan tsan ubsan gcov release

# These are the remaining non-flag goals
GOALS := $(filter-out $(FLAG_GOALS),$(MAKECMDGOALS))

# Build the default goal if only flag goals are specified
FLAG_PREREQS :=
ifndef GOALS
FLAG_PREREQS += bfs
endif

# Make sure that "make release" builds everything, but "make release obj/src/main.o" doesn't
$(FLAG_GOALS): $(FLAG_PREREQS)
	@:
.PHONY: $(FLAG_GOALS)

all: bfs tests
.PHONY: all

$(BIN)/%:
	@$(MKDIR) $(@D)
	+$(CC) $(ALL_LDFLAGS) $^ $(ALL_LDLIBS) -o $@
ifeq ($(OS) $(SANITIZE),FreeBSD y)
	elfctl -e +noaslr $@
endif

$(OBJ)/%.o: %.c $(OBJ)/FLAGS
	@$(MKDIR) $(@D)
	$(CC) $(ALL_CFLAGS) -c $< -o $@

# Save the full set of flags to rebuild everything when they change
$(OBJ)/FLAGS.new:
	@$(MKDIR) $(@D)
	@echo $(CC) : $(ALL_CFLAGS) : $(ALL_LDFLAGS) : $(ALL_LDLIBS) >$@
.PHONY: $(OBJ)/FLAGS.new

# Only update obj/FLAGS if obj/FLAGS.new is different
$(OBJ)/FLAGS: $(OBJ)/FLAGS.new
	@test -e $@ && cmp -s $@ $< && rm $< || mv $< $@

# All object files except the entry point
LIBBFS := \
    $(OBJ)/src/alloc.o \
    $(OBJ)/src/bar.o \
    $(OBJ)/src/bfstd.o \
    $(OBJ)/src/bftw.o \
    $(OBJ)/src/color.o \
    $(OBJ)/src/ctx.o \
    $(OBJ)/src/darray.o \
    $(OBJ)/src/diag.o \
    $(OBJ)/src/dir.o \
    $(OBJ)/src/dstring.o \
    $(OBJ)/src/eval.o \
    $(OBJ)/src/exec.o \
    $(OBJ)/src/fsade.o \
    $(OBJ)/src/ioq.o \
    $(OBJ)/src/mtab.o \
    $(OBJ)/src/opt.o \
    $(OBJ)/src/parse.o \
    $(OBJ)/src/printf.o \
    $(OBJ)/src/pwcache.o \
    $(OBJ)/src/stat.o \
    $(OBJ)/src/trie.o \
    $(OBJ)/src/typo.o \
    $(OBJ)/src/xregex.o \
    $(OBJ)/src/xspawn.o \
    $(OBJ)/src/xtime.o

# The main executable
$(BIN)/bfs: $(OBJ)/src/main.o $(LIBBFS)

# Standalone unit tests
UNITS := alloc bfstd bit trie xtimegm
UNIT_TESTS := $(UNITS:%=$(BIN)/tests/%)
UNIT_CHECKS := $(UNITS:%=check-%)

# Testing utilities
TEST_UTILS := $(BIN)/tests/mksock $(BIN)/tests/xtouch

TESTS := $(UNIT_TESTS) $(TEST_UTILS)

tests: $(TESTS)
.PHONY: tests

$(TESTS): $(BIN)/tests/%: $(OBJ)/tests/%.o $(LIBBFS)

# The different search strategies that we test
STRATEGIES := bfs dfs ids eds
STRATEGY_CHECKS := $(STRATEGIES:%=check-%)

# All the different checks we run
CHECKS := $(UNIT_CHECKS) $(STRATEGY_CHECKS)

check: $(CHECKS)
.PHONY: check $(CHECKS)

$(UNIT_CHECKS): check-%: $(BIN)/tests/%
	$<

$(STRATEGY_CHECKS): check-%: $(BIN)/bfs $(TEST_UTILS)
	./tests/tests.sh --bfs="$(BIN)/bfs -S $*" $(TEST_FLAGS)

# Custom test flags for distcheck
DISTCHECK_FLAGS := -s TEST_FLAGS="--sudo --verbose=skipped"

distcheck:
	+$(MAKE) -B asan ubsan check $(DISTCHECK_FLAGS)
ifneq ($(OS),Darwin)
	+$(MAKE) -B msan ubsan check CC=clang $(DISTCHECK_FLAGS)
endif
	+$(MAKE) -B tsan ubsan check CC=clang $(DISTCHECK_FLAGS)
ifeq ($(OS) $(ARCH),Linux x86_64)
	+$(MAKE) -B check EXTRA_CFLAGS="-m32" ONIG_CONFIG= $(DISTCHECK_FLAGS)
endif
	+$(MAKE) -B release check $(DISTCHECK_FLAGS)
	+$(MAKE) -B check $(DISTCHECK_FLAGS)
	+$(MAKE) check-install $(DISTCHECK_FLAGS)
.PHONY: distcheck

clean:
	$(RM) -r $(BIN) $(OBJ)
.PHONY: clean

install:
	$(MKDIR) $(DESTDIR)$(PREFIX)/bin
	$(INSTALL) -m755 $(BIN)/bfs $(DESTDIR)$(PREFIX)/bin/bfs
	$(MKDIR) $(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -m644 docs/bfs.1 $(DESTDIR)$(MANDIR)/man1/bfs.1
	$(MKDIR) $(DESTDIR)$(PREFIX)/share/bash-completion/completions
	$(INSTALL) -m644 completions/bfs.bash $(DESTDIR)$(PREFIX)/share/bash-completion/completions/bfs
	$(MKDIR) $(DESTDIR)$(PREFIX)/share/zsh/site-functions
	$(INSTALL) -m644 completions/bfs.zsh $(DESTDIR)$(PREFIX)/share/zsh/site-functions/_bfs
	$(MKDIR) $(DESTDIR)$(PREFIX)/share/fish/vendor_completions.d
	$(INSTALL) -m644 completions/bfs.fish $(DESTDIR)$(PREFIX)/share/fish/vendor_completions.d/bfs.fish
.PHONY: install

uninstall:
	$(RM) $(DESTDIR)$(PREFIX)/share/bash-completion/completions/bfs
	$(RM) $(DESTDIR)$(PREFIX)/share/zsh/site-functions/_bfs
	$(RM) $(DESTDIR)$(PREFIX)/share/fish/vendor_completions.d/bfs.fish
	$(RM) $(DESTDIR)$(MANDIR)/man1/bfs.1
	$(RM) $(DESTDIR)$(PREFIX)/bin/bfs
.PHONY: uninstall

check-install:
	+$(MAKE) install DESTDIR=$(BUILDDIR)/pkg
	+$(MAKE) uninstall DESTDIR=$(BUILDDIR)/pkg
	$(BIN)/bfs $(BUILDDIR)/pkg -not -type d -print -exit 1
	$(RM) -r $(BUILDDIR)/pkg
.PHONY: check-install

.SUFFIXES:

-include $(wildcard $(OBJ)/*/*.d)

=== debian/changelog ===
bfs (3.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.6.2.

 -- Chris Lamb <lamby@debian.org>  Sat, 15 Jul 2023 16:54:05 +0100

=== debian/control ===
Source: bfs
Section: utils
Priority: optional
Maintainer: Chris Lamb <lamby@debian.org>
Build-Depends:
 acl,
 debhelper-compat (= 13),
 libacl1-dev [linux-any],
 libcap-dev [linux-any],
 libonig-dev,
Standards-Version: 4.6.2
Homepage: https://github.com/tavianator/bfs
Vcs-Git: https://salsa.debian.org/lamby/pkg-bfs.git
Vcs-Browser: https://salsa.debian.org/lamby/pkg-bfs
Rules-Requires-Root: no

Package: bfs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Breadth-first version of find(1)
 bfs is a variant of the UNIX `find` command that operates breadth-first rather
 than depth-first.
 .
 It tries to be easier to use than `find`, while remaining compatible with
 find(1). For example, bfs is less picky about where you put its arguments.
 bfs also adds some extra options that make some common tasks easier.
 .
 When bfs detects that its output is a terminal, it automatically colors its
 output with the same colors ls uses.

## bfs 3.0.4

=== debian/changelog ===
bfs (3.0.4-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Sat, 21 Oct 2023 09:13:57 +0100

bfs (3.0.2-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Sat, 09 Sep 2023 09:40:05 -0700

## bfs 3.1.1

=== debian/changelog ===
bfs (3.1.1-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Sat, 24 Feb 2024 10:28:49 +0000

bfs (3.1-1) unstable; urgency=medium

  * New upstream release.
  * Add liburing-dev to build-depends.
  * Update debian/docs.

 -- Chris Lamb <lamby@debian.org>  Sun, 11 Feb 2024 13:05:52 -0800

## bfs 3.1.2

=== debian/changelog ===
bfs (3.1.2-1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:33:19 +1100

bfs (3.1.2-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Sun, 03 Mar 2024 15:51:16 +0000

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,15 @@
 Source: bfs
 Section: utils
 Priority: optional
-Maintainer: Chris Lamb <lamby@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends:
  acl,
  debhelper-compat (= 13),
  libacl1-dev [linux-any],
  libcap-dev [linux-any],
  libonig-dev,
+ liburing-dev,
 Standards-Version: 4.6.2
 Homepage: https://github.com/tavianator/bfs
 Vcs-Git: https://salsa.debian.org/lamby/pkg-bfs.git

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# Fix FTBFS on kfreebsd-* architectures
# https://github.com/tavianator/bfs/issues/56
ifneq (,$(filter kfreebsd,$(DEB_HOST_ARCH_OS)))
export DEB_CFLAGS_MAINT_APPEND = -DBFS_HAS_SYS_EXTATTR=0
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_test:
ifneq ($(shell id -u),0)
	dh_auto_test
endif

override_dh_installchangelogs:
	dh_installchangelogs docs/CHANGELOG.md

## bfs 3.3.1

=== Makefile ===
# Copyright © Tavian Barnes <tavianator@tavianator.com>
# SPDX-License-Identifier: 0BSD

# To build bfs, run
#
#     $ ./configure
#     $ make

# Utilities and GNU/BSD portability
include build/prelude.mk

# The default build target
default: bfs
.PHONY: default

# Include the generated build config, if it exists
-include gen/config.mk

## Configuration phase (`./configure`)

# bfs used to have flag-like targets (`make release`, `make asan ubsan`, etc.).
# Direct users to the new configuration system.
asan lsan msan tsan ubsan gcov lint release::
	@printf 'error: `%s %s` is no longer supported. Use `./configure --enable-%s` instead.\n' \
	    "${MAKE}" $@ $@ >&2
	@false

# Print an error if `make` is run before `./configure`
gen/config.mk::
	@if ! [ -e $@ ]; then \
	    printf 'error: You must run `./configure` before `%s`.\n' "${MAKE}" >&2; \
	    false; \
	fi

## Build phase (`make`)

# The main binary
bfs: bin/bfs
.PHONY: bfs

# All binaries
BINS := \
    bin/bfs \
    bin/tests/mksock \
    bin/tests/units \
    bin/tests/xspawnee \
    bin/tests/xtouch

all: ${BINS}
.PHONY: all

# The main binary
bin/bfs: ${LIBBFS} obj/src/main.o

${BINS}:
	@${MKDIR} ${@D}
	+${MSG} "[ LD ] $@" ${CC} ${_CFLAGS} ${_LDFLAGS} ${.ALLSRC} ${_LDLIBS} -o $@
	${POSTLINK}

# Get the .c file for a .o file
CSRC = ${@:obj/%.o=%.c}

# Rebuild when the configuration changes
${OBJS}: gen/config.mk
	@${MKDIR} ${@D}
	${MSG} "[ CC ] ${CSRC}" ${CC} ${_CPPFLAGS} ${_CFLAGS} -c ${CSRC} -o $@

# Save the version number to this file, but only update version.c if it changes
gen/version.c.new::
	@${MKDIR} ${@D}
	@printf 'const char bfs_version[] = "' >$@
	@if [ "$$VERSION" ]; then \
	    printf '%s' "$$VERSION"; \
	elif test -e src/../.git && command -v git >/dev/null 2>&1; then \
	    git -C src/.. describe --always --dirty; \
	else \
	    echo "3.3.1"; \
	fi | tr -d '\n' >>$@
	@printf '";\n' >>$@

gen/version.c: gen/version.c.new
	@test -e $@ && cmp -s $@ ${.ALLSRC} && rm ${.ALLSRC} || mv ${.ALLSRC} $@

obj/gen/version.o: gen/version.c

## Test phase (`make check`)

# Unit test binaries
UTEST_BINS := \
    bin/tests/units \
    bin/tests/xspawnee

# Integration test binaries
ITEST_BINS := \
    bin/tests/mksock \
    bin/tests/xtouch

# Build (but don't run) test binaries
tests: ${UTEST_BINS} ${ITEST_BINS}
.PHONY: tests

# Run all the tests
check: unit-tests integration-tests
.PHONY: check

# Run the unit tests
unit-tests: ${UTEST_BINS}
	${MSG} "[TEST] tests/units" bin/tests/units
.PHONY: unit-tests

bin/tests/units: \
    ${UNIT_OBJS} \
    ${LIBBFS}

bin/tests/xspawnee: \
    obj/tests/xspawnee.o

# The different flag combinations we check
INTEGRATIONS := default dfs ids eds j1 j2 j3 s
INTEGRATION_TESTS := ${INTEGRATIONS:%=check-%}

# Check just `bfs`
check-default: bin/bfs ${ITEST_BINS}
	+${MSG} "[TEST] bfs" \
	    ./tests/tests.sh --make="${MAKE}" --bfs="bin/bfs" ${TEST_FLAGS}

# Check the different search strategies
check-dfs check-ids check-eds: bin/bfs ${ITEST_BINS}
	+${MSG} "[TEST] bfs -S ${@:check-%=%}" \
	    ./tests/tests.sh --make="${MAKE}" --bfs="bin/bfs -S ${@:check-%=%}" ${TEST_FLAGS}

# Check various flags
check-j1 check-j2 check-j3 check-s: bin/bfs ${ITEST_BINS}
	+${MSG} "[TEST] bfs -${@:check-%=%}" \
	    ./tests/tests.sh --make="${MAKE}" --bfs="bin/bfs -${@:check-%=%}" ${TEST_FLAGS}

# Run the integration tests
integration-tests: ${INTEGRATION_TESTS}
.PHONY: integration-tests

bin/tests/mksock: \
    obj/tests/mksock.o \
    ${LIBBFS}

bin/tests/xtouch: \
    obj/tests/xtouch.o \
    ${LIBBFS}

# `make distcheck` configurations
DISTCHECKS := \
    distcheck-asan \
    distcheck-msan \
    distcheck-tsan \
    distcheck-m32 \
    distcheck-release

# Test multiple configurations
distcheck:
	@+${MAKE} distcheck-asan
	@+test "$$(uname)" = Darwin || ${MAKE} distcheck-msan
	@+test "$$(uname)" = FreeBSD || ${MAKE} distcheck-tsan
	@+test "$$(uname)-$$(uname -m)" != Linux-x86_64 || ${MAKE} distcheck-m32
	@+${MAKE} distcheck-release
.PHONY: distcheck

# Per-distcheck configuration
DISTCHECK_CONFIG_asan := --enable-asan --enable-ubsan
DISTCHECK_CONFIG_msan := --enable-msan --enable-ubsan CC=clang
DISTCHECK_CONFIG_tsan := --enable-tsan --enable-ubsan CC=clang
DISTCHECK_CONFIG_m32 := EXTRA_CFLAGS="-m32" PKG_CONFIG_LIBDIR=/usr/lib32/pkgconfig
DISTCHECK_CONFIG_release := --enable-release

${DISTCHECKS}::
	@${MKDIR} $@
	@+cd $@ \
	    && ../configure ${DISTCHECK_CONFIG_${@:distcheck-%=%}} \
	    && ${MAKE} check TEST_FLAGS="--sudo --verbose=skipped"

## Packaging (`make install`)

DEST_PREFIX := ${DESTDIR}${PREFIX}
DEST_MANDIR := ${DESTDIR}${MANDIR}

install::
	${Q}${MKDIR} ${DEST_PREFIX}/bin
	${MSG} "[INST] bin/bfs" \
	    ${INSTALL} -m755 bin/bfs ${DEST_PREFIX}/bin/bfs
	${Q}${MKDIR} ${DEST_MANDIR}/man1
	${MSG} "[INST] man/man1/bfs.1" \
	    ${INSTALL} -m644 docs/bfs.1 ${DEST_MANDIR}/man1/bfs.1
	${Q}${MKDIR} ${DEST_PREFIX}/share/bash-completion/completions
	${MSG} "[INST] completions/bfs.bash" \
	    ${INSTALL} -m644 completions/bfs.bash ${DEST_PREFIX}/share/bash-completion/completions/bfs
	${Q}${MKDIR} ${DEST_PREFIX}/share/zsh/site-functions
	${MSG} "[INST] completions/bfs.zsh" \
	    ${INSTALL} -m644 completions/bfs.zsh ${DEST_PREFIX}/share/zsh/site-functions/_bfs
	${Q}${MKDIR} ${DEST_PREFIX}/share/fish/vendor_completions.d
	${MSG} "[INST] completions/bfs.fish" \
	    ${INSTALL} -m644 completions/bfs.fish ${DEST_PREFIX}/share/fish/vendor_completions.d/bfs.fish

uninstall::
	${MSG} "[ RM ] completions/bfs.bash" \
	    ${RM} ${DEST_PREFIX}/share/bash-completion/completions/bfs
	${MSG} "[ RM ] completions/bfs.zsh" \
	    ${RM} ${DEST_PREFIX}/share/zsh/site-functions/_bfs
	${MSG} "[ RM ] completions/bfs.fish" \
	    ${RM} ${DEST_PREFIX}/share/fish/vendor_completions.d/bfs.fish
	${MSG} "[ RM ] man/man1/bfs.1" \
	    ${RM} ${DEST_MANDIR}/man1/bfs.1
	${MSG} "[ RM ] bin/bfs" \
	    ${RM} ${DEST_PREFIX}/bin/bfs

# Check that `make install` works and `make uninstall` removes everything
check-install::
	+${MAKE} install DESTDIR=pkg
	+${MAKE} uninstall DESTDIR=pkg
	bin/bfs pkg -not -type d -print -exit 1
	${RM} -r pkg

## Cleanup (`make clean`)

# Clean all build products
clean::
	${MSG} "[ RM ] bin obj" \
	    ${RM} -r bin obj

# Clean everything, including generated files
distclean: clean
	${MSG} "[ RM ] gen" \
	    ${RM} -r gen ${DISTCHECKS}
.PHONY: distclean

=== debian/changelog ===
bfs (3.3.1-4) unstable; urgency=medium

  * Correctly (i.e. explicitly) include buildtools.mk in debian/rules; it is
    not yet included by default. Thanks, Helmut. (Closes: #1078525)

 -- Chris Lamb <lamby@debian.org>  Thu, 15 Aug 2024 10:59:41 +0100

bfs (3.3.1-3) unstable; urgency=medium

  * Pass CC to ./configure script to fix cross-build support. Thanks, Helmut!
    (Closes: #1078525)

 -- Chris Lamb <lamby@debian.org>  Mon, 12 Aug 2024 08:44:01 +0100

bfs (3.3.1-2) unstable; urgency=medium

  * Apply patch from upstream to fix FTBFS on riscv64. (Closes: #1072933)

 -- Chris Lamb <lamby@debian.org>  Tue, 11 Jun 2024 10:49:08 +0100

bfs (3.3.1-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Tue, 04 Jun 2024 08:26:30 +0100

bfs (3.2-1) unstable; urgency=medium

  * New upstream release.
  * Don't call upstream's (new) configure file.
  * Update renamed Lintian tag.

 -- Chris Lamb <lamby@debian.org>  Wed, 08 May 2024 14:58:05 +0100

bfs (3.1.3-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Sat, 09 Mar 2024 09:34:31 +0000

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: bfs
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Chris Lamb <lamby@debian.org>
+Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends:
  acl,
  debhelper-compat (= 13),

## bfs 4.0.2

=== debian/changelog ===
bfs (4.0.2-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Fri, 27 Sep 2024 08:20:05 -0700

bfs (4.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Drop 0001-PATCH-atomic-Fix-RISC-V-build-with-GCC-14.patch; applied
    upstream.

 -- Chris Lamb <lamby@debian.org>  Sat, 24 Aug 2024 09:51:02 +0100

## bfs 4.0.3

=== debian/changelog ===
bfs (4.0.3-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Fri, 25 Oct 2024 10:53:49 -0700

## bfs 4.0.4

=== Makefile ===
--- 
+++ 
@@ -27,10 +27,11 @@
 
 # Print an error if `make` is run before `./configure`
 gen/config.mk::
-	@if ! [ -e $@ ]; then \
+	if ! [ -e $@ ]; then \
 	    printf 'error: You must run `./configure` before `%s`.\n' "${MAKE}" >&2; \
 	    false; \
 	fi
+.SILENT: gen/config.mk
 
 ## Build phase (`make`)
 
@@ -49,8 +50,43 @@
 all: ${BINS}
 .PHONY: all
 
+# All object files except the entry point
+LIBBFS := \
+    obj/src/alloc.o \
+    obj/src/bar.o \
+    obj/src/bfstd.o \
+    obj/src/bftw.o \
+    obj/src/color.o \
+    obj/src/ctx.o \
+    obj/src/diag.o \
+    obj/src/dir.o \
+    obj/src/dstring.o \
+    obj/src/eval.o \
+    obj/src/exec.o \
+    obj/src/expr.o \
+    obj/src/fsade.o \
+    obj/src/ioq.o \
+    obj/src/mtab.o \
+    obj/src/opt.o \
+    obj/src/parse.o \
+    obj/src/printf.o \
+    obj/src/pwcache.o \
+    obj/src/sighook.o \
+    obj/src/stat.o \
+    obj/src/thread.o \
+    obj/src/trie.o \
+    obj/src/typo.o \
+    obj/src/version.o \
+    obj/src/xregex.o \
+    obj/src/xspawn.o \
+    obj/src/xtime.o
+
+# All object files
+OBJS := ${LIBBFS}
+
 # The main binary
-bin/bfs: ${LIBBFS} obj/src/main.o
+bin/bfs: obj/src/main.o ${LIBBFS}
+OBJS += obj/src/main.o
 
 ${BINS}:
 	@${MKDIR} ${@D}
@@ -60,28 +96,17 @@
 # Get the .c file for a .o file
 CSRC = ${@:obj/%.o=%.c}
 
-# Rebuild when the configuration changes
-${OBJS}: gen/config.mk
-	@${MKDIR} ${@D}
-	${MSG} "[ CC ] ${CSRC}" ${CC} ${_CPPFLAGS} ${_CFLAGS} -c ${CSRC} -o $@
-
 # Save the version number to this file, but only update version.c if it changes
-gen/version.c.new::
-	@${MKDIR} ${@D}
-	@printf 'const char bfs_version[] = "' >$@
-	@if [ "$$VERSION" ]; then \
-	    printf '%s' "$$VERSION"; \
-	elif test -e src/../.git && command -v git >/dev/null 2>&1; then \
-	    git -C src/.. describe --always --dirty; \
-	else \
-	    echo "3.3.1"; \
-	fi | tr -d '\n' >>$@
-	@printf '";\n' >>$@
-
-gen/version.c: gen/version.c.new
-	@test -e $@ && cmp -s $@ ${.ALLSRC} && rm ${.ALLSRC} || mv ${.ALLSRC} $@
-
-obj/gen/version.o: gen/version.c
+gen/version.i.new::
+	${MKDIR} ${@D}
+	build/version.sh | tr -d '\n' | build/embed.sh >$@
+.SILENT: gen/version.i.new
+
+gen/version.i: gen/version.i.new
+	test -e $@ && cmp -s $@ ${.ALLSRC} && ${RM} ${.ALLSRC} || mv ${.ALLSRC} $@
+.SILENT: gen/version.i
+
+obj/src/version.o: gen/version.i
 
 ## Test phase (`make check`)
 
@@ -108,12 +133,24 @@
 	${MSG} "[TEST] tests/units" bin/tests/units
 .PHONY: unit-tests
 
-bin/tests/units: \
-    ${UNIT_OBJS} \
-    ${LIBBFS}
-
-bin/tests/xspawnee: \
-    obj/tests/xspawnee.o
+# Unit test objects
+UNIT_OBJS := \
+    obj/tests/alloc.o \
+    obj/tests/bfstd.o \
+    obj/tests/bit.o \
+    obj/tests/ioq.o \
+    obj/tests/list.o \
+    obj/tests/main.o \
+    obj/tests/sighook.o \
+    obj/tests/trie.o \
+    obj/tests/xspawn.o \
+    obj/tests/xtime.o
+
+bin/tests/units: ${UNIT_OBJS} ${LIBBFS}
+OBJS += ${UNIT_OBJS}
+
+bin/tests/xspawnee: obj/tests/xspawnee.o
+OBJS += obj/tests/xspawnee.o
 
 # The different flag combinations we check
 INTEGRATIONS := default dfs ids eds j1 j2 j3 s
@@ -138,13 +175,11 @@
 integration-tests: ${INTEGRATION_TESTS}
 .PHONY: integration-tests
 
-bin/tests/mksock: \
-    obj/tests/mksock.o \
-    ${LIBBFS}
-
-bin/tests/xtouch: \
-    obj/tests/xtouch.o \
-    ${LIBBFS}
+bin/tests/mksock: obj/tests/mksock.o ${LIBBFS}
+OBJS += obj/tests/mksock.o
+
+bin/tests/xtouch: obj/tests/xtouch.o ${LIBBFS}
+OBJS += obj/tests/xtouch.o
 
 # `make distcheck` configurations
 DISTCHECKS := \
@@ -161,6 +196,8 @@
 	@+test "$$(uname)" = FreeBSD || ${MAKE} distcheck-tsan
 	@+test "$$(uname)-$$(uname -m)" != Linux-x86_64 || ${MAKE} distcheck-m32
 	@+${MAKE} distcheck-release
+	@+${MAKE} -C distcheck-release check-install
+	@+test "$$(uname)" != Linux || ${MAKE} check-man
 .PHONY: distcheck
 
 # Per-distcheck configuration
@@ -172,11 +209,33 @@
 
 ${DISTCHECKS}::
 	@${MKDIR} $@
+	@test "$${GITHUB_ACTIONS-}" != true || printf '::group::%s\n' $@
 	@+cd $@ \
-	    && ../configure ${DISTCHECK_CONFIG_${@:distcheck-%=%}} \
+	    && ../configure MAKE="${MAKE}" ${DISTCHECK_CONFIG_${@:distcheck-%=%}} \
 	    && ${MAKE} check TEST_FLAGS="--sudo --verbose=skipped"
-
-## Packaging (`make install`)
+	@test "$${GITHUB_ACTIONS-}" != true || printf '::endgroup::\n'
+
+## Automatic dependency tracking
+
+# Rebuild when the configuration changes
+${OBJS}: gen/config.mk
+	@${MKDIR} ${@D}
+	${MSG} "[ CC ] ${CSRC}" ${CC} ${_CPPFLAGS} ${_CFLAGS} -c ${CSRC} -o $@
+
+# Include any generated dependency files
+-include ${OBJS:.o=.d}
+
+## Packaging (`make dist`, `make install`)
+
+TARBALL = bfs-$$(build/version.sh).tar.gz
+
+dist:
+	${MSG} "[DIST] ${TARBALL}" git archive HEAD -o ${TARBALL}
+
+distsign: dist
+	${MSG} "[SIGN] ${TARBALL}" ssh-keygen -Y sign -q -f $$(git config user.signingkey) -n file ${TARBALL}
+
+.PHONY: dist distsign
 
 DEST_PREFIX := ${DESTDIR}${PREFIX}
 DEST_MANDIR := ${DESTDIR}${MANDIR}
@@ -217,6 +276,12 @@
 	bin/bfs pkg -not -type d -print -exit 1
 	${RM} -r pkg
 
+# Check man page markup
+check-man::
+	${MSG} "[LINT] docs/bfs.1"
+	${Q}groff -man -rCHECKSTYLE=3 -ww -b -z docs/bfs.1
+	${Q}mandoc -Tlint -Wwarning docs/bfs.1
+
 ## Cleanup (`make clean`)
 
 # Clean all build products
@@ -226,6 +291,6 @@
 
 # Clean everything, including generated files
 distclean: clean
-	${MSG} "[ RM ] gen" \
+	${MSG} "[ RM ] gen distcheck-*" \
 	    ${RM} -r gen ${DISTCHECKS}
 .PHONY: distclean

=== debian/changelog ===
bfs (4.0.4-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Fri, 08 Nov 2024 09:34:41 -0800

## bfs 4.0.5

=== debian/changelog ===
bfs (4.0.5-2) unstable; urgency=medium

  * Fix a test failure due to changes in gawk/bash. (Closes: #1095329)

 -- Chris Lamb <lamby@debian.org>  Sat, 08 Feb 2025 09:39:20 +0000

bfs (4.0.5-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Fri, 24 Jan 2025 11:44:24 +0000

## bfs 4.0.6

=== debian/changelog ===
bfs (4.0.6-1) unstable; urgency=medium

  * New upstream release.
  * Drop 0001-PATCH-tests-Use-if-it-exists.patch; applied upstream.

 -- Chris Lamb <lamby@debian.org>  Fri, 28 Feb 2025 11:01:57 +0000

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  libcap-dev [linux-any],
  libonig-dev,
  liburing-dev,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/tavianator/bfs
 Vcs-Git: https://salsa.debian.org/lamby/pkg-bfs.git
 Vcs-Browser: https://salsa.debian.org/lamby/pkg-bfs

=== debian/tests/control ===
Tests: 0001-smoketest
Restrictions: needs-root

## bfs 4.1

=== Makefile ===
--- 
+++ 
@@ -43,9 +43,11 @@
 BINS := \
     bin/bfs \
     bin/tests/mksock \
+    bin/tests/ptyx \
     bin/tests/units \
     bin/tests/xspawnee \
-    bin/tests/xtouch
+    bin/tests/xtouch \
+    bin/bench/ioq
 
 all: ${BINS}
 .PHONY: all
@@ -90,7 +92,7 @@
 
 ${BINS}:
 	@${MKDIR} ${@D}
-	+${MSG} "[ LD ] $@" ${CC} ${_CFLAGS} ${_LDFLAGS} ${.ALLSRC} ${_LDLIBS} -o $@
+	+${MSG} "[ LD ] $@" ${CC} ${_CFLAGS} ${_LDFLAGS} $^ ${_LDLIBS} -o $@
 	${POSTLINK}
 
 # Get the .c file for a .o file
@@ -103,7 +105,7 @@
 .SILENT: gen/version.i.new
 
 gen/version.i: gen/version.i.new
-	test -e $@ && cmp -s $@ ${.ALLSRC} && ${RM} ${.ALLSRC} || mv ${.ALLSRC} $@
+	test -e $@ && cmp -s $@ $^ && ${RM} $^ || mv $^ $@
 .SILENT: gen/version.i
 
 obj/src/version.o: gen/version.i
@@ -118,6 +120,7 @@
 # Integration test binaries
 ITEST_BINS := \
     bin/tests/mksock \
+    bin/tests/ptyx \
     bin/tests/xtouch
 
 # Build (but don't run) test binaries
@@ -178,6 +181,9 @@
 bin/tests/mksock: obj/tests/mksock.o ${LIBBFS}
 OBJS += obj/tests/mksock.o
 
+bin/tests/ptyx: obj/tests/ptyx.o ${LIBBFS}
+OBJS += obj/tests/ptyx.o
+
 bin/tests/xtouch: obj/tests/xtouch.o ${LIBBFS}
 OBJS += obj/tests/xtouch.o
 
@@ -214,6 +220,14 @@
 	    && ../configure MAKE="${MAKE}" ${DISTCHECK_CONFIG_${@:distcheck-%=%}} \
 	    && ${MAKE} check TEST_FLAGS="--sudo --verbose=skipped"
 	@test "$${GITHUB_ACTIONS-}" != true || printf '::endgroup::\n'
+
+## Benchmarks (`make bench`)
+
+bench: bin/bench/ioq
+.PHONY: bench
+
+bin/bench/ioq: obj/bench/ioq.o ${LIBBFS}
+OBJS += obj/bench/ioq.o
 
 ## Automatic dependency tracking

=== debian/changelog ===
bfs (4.1-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.2.

 -- Chris Lamb <lamby@debian.org>  Fri, 15 Aug 2025 08:17:09 -0700

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  libcap-dev [linux-any],
  libonig-dev,
  liburing-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/tavianator/bfs
 Vcs-Git: https://salsa.debian.org/lamby/pkg-bfs.git
 Vcs-Browser: https://salsa.debian.org/lamby/pkg-bfs

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,7 @@
 #!/usr/bin/make -f
 
-include /usr/share/dpkg/architecture.mk
+include /usr/share/dpkg/default.mk
+include /usr/share/dpkg/buildtools.mk
 
 # Fix FTBFS on kfreebsd-* architectures
 # https://github.com/tavianator/bfs/issues/56
@@ -13,6 +14,9 @@
 %:
 	dh $@
 
+override_dh_auto_configure:
+	./configure 'CC=$(CC)'
+
 override_dh_auto_test:
 ifneq ($(shell id -u),0)
 	dh_auto_test

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
    https://github.com/tavianator/bfs/tags \
    (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
